#include "quakedef.h"

cvar_t r_crosshairalpha = {"r_crosshairalpha", "0.5", true};
cvar_t r_crosshairflashspeed = {"r_crosshairflashspeed", "2", true};
cvar_t r_crosshairflashrange = {"r_crosshairflashrange", "0.1", true};

#define NUMCROSSHAIRS 1

int crosshairtex[NUMCROSSHAIRS];

char crosshairtex1[16*16] =
	"0000000000000000"
	"0000000000000000"
	"0000000000000000"
	"0003000000003000"
	"0000500000050000"
	"0000070000700000"
	"0000007007000000"
	"0000000000000000"
	"0000000000000000"
	"0000007007000000"
	"0000070000700000"
	"0000500000050000"
	"0003000000003000"
	"0000000000000000"
	"0000000000000000"
	"0000000000000000"
;

void r_crosshairs_start()
{
	int i;
	byte data[64*64][4];
	for (i = 0;i < 16*16;i++)
	{
		data[i][0] = data[i][1] = data[i][2] = 255;
		data[i][3] = (crosshairtex1[i] - '0') * 255 / 7;
	}
	crosshairtex[0] = GL_LoadTexture("crosshair0", 16, 16, &data[0][0], false, true, 4);
}

void r_crosshairs_shutdown()
{
}

void R_Crosshairs_Init()
{
	Cvar_RegisterVariable(&r_crosshairalpha);
	Cvar_RegisterVariable(&r_crosshairflashspeed);
	Cvar_RegisterVariable(&r_crosshairflashrange);
	R_RegisterModule("R_Crosshairs", r_crosshairs_start, r_crosshairs_shutdown);
}

void DrawCrosshair(int num)
{
	byte *color;
	float scale, base;
//	Draw_Character (r_refdef.vrect.x + r_refdef.vrect.width/2, r_refdef.vrect.y + r_refdef.vrect.height/2, '+');
	if (num < 0 || num >= NUMCROSSHAIRS)
		num = 0;
	if (cl.viewentity)
		color = (byte *) &d_8to24table[(cl.scores[cl.viewentity-1].colors & 15)*16 + 15];
	else
		color = (byte *) &d_8to24table[15];
	if (r_crosshairflashspeed.value >= 0.01f)
//		scale = (sin(realtime * r_crosshairflashspeed.value * (M_PI*2.0f)) * r_crosshairflashrange.value + 1.0f) * (1.0f / 255.0f);
		base = (sin(realtime * r_crosshairflashspeed.value * (M_PI*2.0f)) * r_crosshairflashrange.value);
	else
		base = 0.0f;
	scale = 1.0f / 255.0f;
	Draw_GenericPic(crosshairtex[num], color[0] * scale + base, color[1] * scale + base, color[2] * scale + base, r_crosshairalpha.value, r_refdef.vrect.x + r_refdef.vrect.width * 0.5f - 8.0f, r_refdef.vrect.y + r_refdef.vrect.height * 0.5f - 8.0f, 16.0f, 16.0f);
}

